
package org.act.services.thread;
import java.util.Hashtable;

public class ThreadWithAttributes extends Thread {
    
    private Object control;
    public static int MAX_NOTES=16;
    private Object notes[]=new Object[MAX_NOTES];
    private Hashtable attributes=new Hashtable();
    private String currentStage;
    private Object param;
    
    private Object thData[];
    public ThreadWithAttributes(Object control, Runnable r) {
        super(r);
        this.control=control;
    }
    
    public final Object[] getThreadData(Object control ) {
        return thData;
    }
    
    public final void setThreadData(Object control, Object thData[] ) {
        this.thData=thData;
    }
    
    public final void setNote( Object control, int id, Object value ) {
        if( this.control != control ) return;
        notes[id]=value;
    }
    
    public final String getCurrentStage(Object control) {
        if( this.control != control ) return null;
        return currentStage;
    }
    
    public final Object getParam(Object control) {
        if( this.control != control ) return null;
        return param;
    }
    public final void setCurrentStage(Object control, String currentStage) {
        if( this.control != control ) return;
        this.currentStage = currentStage;
    }
    public final void setParam( Object control, Object param ) {
        if( this.control != control ) return;
        this.param=param;
    }
    public final Object getNote(Object control, int id ) {
        if( this.control != control ) return null;
        return notes[id];
    }
    
    public final Hashtable getAttributes(Object control) {
        return attributes;
    }
}
