
package org.act.services;
import org.act.metaset.Metaset;
import org.act.services.wsdl.model.ServicesContext;
import org.act.services.wsdl.model.ServicesMethod;

public class ServicesObject {
	
		private ServicesContext serviceContext;
	
		private ServicesMethod method;
		private IMessageContext messageContext;
	
	public ServicesObject(){}
	
	
	
	public ServicesObject(ServicesContext serviceContext, IMessageContext messageContext, ServicesMethod method) {
		this.method = method;
		this.messageContext = messageContext;
		this.serviceContext = serviceContext;
	}
	
	
	
	public IMessageContext getMessageContext() {
		return messageContext;
	}
	
	public ServicesContext getServiceContext() {
		return serviceContext;
	}
	
	public void setMessageContext(IMessageContext context) {
		messageContext = context;
	}
	
	public void setServiceContext(ServicesContext context) {
		serviceContext = context;
	}
	
	public Metaset getRequestServices() {
		return messageContext.getRequestServices();
			}
	
	public void setResponseServices(Metaset msg) {
		messageContext.setResponseServices(msg);
	}
	
	
	public ServicesMethod getServicesMethod() {
		return method;
	}
	
	public void setMethod(ServicesMethod method) {
		this.method = method;
	}
}
