
package org.act.services.wsdl.model;
import java.util.HashMap;
import java.util.Map;

public class ServicesContextPoolImpl implements IServicesContextPool {
	
	private Map map = new HashMap();
	
	public void put(ServicesContext ws) {
		synchronized (map) {
			map.put(ws.getWebServiceName(), ws);
		}
	}
	
	public void remove(String name) {
		synchronized (map) {
			map.remove(name);
		}
	}
	
	public ServicesContext getService(String name) {
		synchronized (map) {
			return (ServicesContext)map.get(name);
		}
	}
	public ServicesContext[] getServices() {
		synchronized (map) {
			return (ServicesContext[])map.values().toArray(new ServicesContext[0]);
		}
	}
}
