
package org.act.services.transaction.participant;


import org.act.services.transaction.util.*;
import org.act.services.transaction.manager.*;
import org.act.services.transaction.messages.*;
public class InferiorContext {
	  
    private String txId = null;
    
    private String inferiorId_ = null;
    
    private String superiorId_ = null;
    
    private Resource resource_ = null;
    
    private String status_ = Status.STATUS_CREATED;
        
    private String inferiorAdd_ = null;
    
    private String superiorAdd_ = null;
    
    
    private long startTime = 0;
    
    
    private long stopTime=0;
    
    public InferiorContext(String txId)
    {
        this.txId = txId;
    }
    
    public String getTransactionId()
    {
        return this.txId;
    }
    
    public void setInferiorId(String inferiorId)
    {
        this.inferiorId_ = inferiorId;
    }
    
    public String getInferiorId()
    {
        return this.inferiorId_;
    }
    
    public void setSuperiorId(String superiorId)
    {
        this.superiorId_ = superiorId;
    }
    
    public String getSuperiorId()
    {
        return this.superiorId_;
    }
    
    public void setStatus(String status)
    {
        this.status_ = status;
    }
    
    public String getStatus()
    {
        return this.status_;
    }
    
    public void setResource(Resource resource)
    {
        this.resource_ = resource;
    }
    
    public Resource getResource()
    {
        return this.resource_;
    }
    
    public void setInfeirorAddress(String address)
    {
        this.inferiorAdd_ = address;
    }
    
    public String getInferiorAddress()
    {
        if (inferiorAdd_ == null)
        {
            inferiorAdd_ = TxUri.getUrlFromUri(inferiorId_);
        }
        return inferiorAdd_;
    }
    
    public void setSuperiorAddress(String address)
    {
        this.superiorAdd_ = address;
    }
    
    public String getSuperiorAddress()
    {
        if (superiorAdd_ == null)
        {
            superiorAdd_ = TxUri.getUrlFromUri(superiorId_);
        }
        return superiorAdd_;
    }
	
	public long getStartTime() {
		return startTime;
	}
	
	public void setStartTime(long startTime) {
		this.startTime = startTime;
	}
	
	public long getStopTime() {
		return stopTime;
	}
	
	public void setStopTime(long stopTime) {
		this.stopTime = stopTime;
	}
}
