
package org.act.services.transaction.util;

import java.util.*;
public class XHashtable {
    
    Hashtable xHashtable = null;
    
    public void put(Object key, Object val)
    {
        if (xHashtable == null)
        {
            xHashtable = new Hashtable();
        }
        Vector v = (Vector)xHashtable.get(key);
        if (v == null)
        {
            v = new Vector();
        }
        v.addElement(val);
        xHashtable.put(key, v);
    }
    
    public Vector get(Object key)
    {
        return (xHashtable == null ? null : (Vector)xHashtable.get(key));
    }
    
    public Object getSingle(Object key)
    {
        if (xHashtable == null)
        {
            return null;
        }
        Vector v = get(key);
        return (v == null ? null : v.elementAt(0));
    }
    
    public Object getSingle(Object key, int pos)
    {
        if (xHashtable == null || pos < 0)
        {
            return null;
        }
        Vector v = get(key);
        return (v == null || v.size() <= pos ? null : v.elementAt(pos));
    }
    
    public Set keySet()
    {
        return (xHashtable == null ? null : xHashtable.keySet());
    }
    
    public String toString()
    {
        if (xHashtable == null)
        {
            return null;
        }
        StringBuffer buf = new StringBuffer();
        Iterator keys = xHashtable.keySet().iterator();
        while (keys.hasNext())
        {
            Object key = keys.next();
            Vector v = (Vector)xHashtable.get(key);
            for (int i = 0; i < v.size(); i++)
            {
                buf.append(key + "=" + v.elementAt(i) + "\n");
            }
        }
        return buf.toString();
    }
    public static void main(String[] args)
    {
        XHashtable XHashtable1 = new XHashtable();
    }
}
