
package org.act.services;
import java.io.IOException;
import org.act.metaset.Metaset;
import org.act.services.thread.ThreadPoolRunnable;

public interface ITransportContext {
	
		public String getTransportProtocolName();
	
		public RequestTransportContext getRequestTransportContext();
	public void setRequestTransportContext(RequestTransportContext requestTransportContext);
	
		public ResponseTransportContext getResponseTransportContext();
	public void setResponseTransportContext(ResponseTransportContext responseTransportContext);
	
		interface RequestTransportContext {
				Metaset getContent() throws IOException;
				IAttachment[] getAttachments() throws IOException;
	}
	
		interface ResponseTransportContext {
				void setContent(Metaset response);
				void setAttachments(IAttachment[] attachments);
				ThreadPoolRunnable getResponseHandler();
	}
}
