
package org.act.services.workflow.activity.basic;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.expression.GeneralExpression;

public class AssignImpl extends ActivityImpl {
	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 	 
	public void process() {
				super.process();
		this.startProcess();
		Metaset copys = this.activity.filter(".\\copy");
		for (int i = 0; i < copys.getChilds().size(); i++) {
			Metaset copy = (Metaset) copys.getChilds().get(i);
			Metaset from = (Metaset) copy.getChilds().get(0);
			Metaset to = (Metaset) copy.getChilds().get(1);
			String expression = from.selector(".\\", "expression");
			String toVariable = to.selector(".\\", "variable");
			String toPart = to.selector(".\\", "part");
			if (expression != null) {
				exp2partOfVar(expression, toVariable, toPart);
			} else {
				String fromVariable = from.selector(".\\", "variable");
				String fromPart = from.selector(".\\", "part");
				partOfVar2partOfVar(fromVariable, fromPart, toVariable, toPart);
			}
		}
		this.endProcess();
	}
	
	private void exp2partOfVar(String exp, String var, String part) {
		String original = new String(this.rc.getVariables().getVarPartValue(
				var, part));
		try {
			this.rc.getVariables().setVarPartValue(var, part,
					GeneralExpression.getExpressionValue(exp));
		} catch (Exception e) {
						e.printStackTrace();
		}
		System.out.println("Expression: " + exp);
		System.out.println("TO  " + "variable: " + var + "  part: " + part
				+ "  value: " + original);
		System.out.println("After assign");
		System.out.println("variable: " + var + "  part: " + part + "  value: "
				+ this.rc.getVariables().getVarPartValue(var, part));
	}
	
	private void partOfVar2partOfVar(String Fvar, String Fpart, String Tvar,
			String Tpart) {
		String original = new String(this.rc.getVariables().getVarPartValue(
				Tvar, Tpart));
		this.rc.getVariables().setVarPartValue(Tvar, Tpart,
				this.rc.getVariables().getVarPartValue(Fvar, Fpart));
		System.out.println("FROM  " + "variable: " + Fvar + "  part: " + Fpart
				+ "  value: "
				+ this.rc.getVariables().getVarPartValue(Fvar, Fpart));
		System.out.println("TO  " + "variable: " + Tvar + "  part: " + Tpart
				+ "  value: " + original);
		System.out.println("After assign");
		System.out.println("variable: " + Tvar + "  part: " + Tpart
				+ "  value: "
				+ this.rc.getVariables().getVarPartValue(Tvar, Tpart));
	}
	
	public AssignImpl(Metaset activity, WorkflowRuntimeContext rc, Stack stack) {
		super(activity, rc, stack);
			}
}
