
package org.act.services.workflow.activity.basic;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.MessageContext;
import org.act.services.runtime.IRuntime;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;

public class ReplyImpl extends ActivityImpl {
	private IRuntime runtime;
									public void process() {
				super.process();
		this.startProcess();
		String partnerLink = activity.selector(".\\", "partnerLink");
		String portType = activity.selector(".\\", "portType");
		String operation = activity.selector(".\\", "operation");
		String variable = activity.selector(".\\", "variable");
		Metaset mCorrelations = activity.filter(".\\correlations\\*");
		
		System.out.println("partnerLink: "+partnerLink+"  portType: "+portType);
		System.out.println("operation: "+operation+"  variable: "+variable);
		
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
				
				String set = mCorrelationSet.selector(".\\","set");
				String initiate = mCorrelationSet.selector(".\\", "initiate");
				
				System.out.println("correlation  set: "+set+"  initiate: "+initiate);
			}
		}
		Metaset mVariable = this.rc.getVariables().getVar(variable);
		Metaset cs = this.getCSOut(variable,mCorrelations);
		
		MessageContext mc = (MessageContext) rc.getPartnerLinkMgCxtMap().get(partnerLink);
		
		boolean success = mc.generateSOAP(mc, operation, mVariable, cs, this.runtime);
		
		if(success) {
			log.info(sm.getString("org.act.wswf.activity.reply.success"));
		}
		else{
			log.info(sm.getString("org.act.wswf.activity.reply.unsuccess"));
		}
		this.endProcess();
	}
	
	
	private Metaset getCSOut(String variable,Metaset mCorrelations) {
		Metaset csOut = new Metaset("CorrelationSets");
		if (mCorrelations != null) {
			for (int i = 0; i < mCorrelations.getChilds().size(); i++) {
				Metaset mCorrelationSet = (Metaset) mCorrelations.getChilds()
						.get(i);
								String correlationSetName = mCorrelationSet.selector(".\\",
						"set");
								String initiate = mCorrelationSet.selector(".\\", "initiate");
				if ((initiate != null) && (initiate.equals("yes"))) {
					this.rc.getCorrelationSets().setCorrelationSetFromVar(
							correlationSetName, variable);
					Metaset correlationSet = this.rc.getCorrelationSets()
							.getCorrelationSetOnName(correlationSetName);
					csOut.add(correlationSet);
				} else {
					Metaset correlationSet = this.rc.getCorrelationSets()
							.getCorrelationSetOnName(correlationSetName);
					csOut.add(correlationSet);
				}
			}
		}
		return csOut;
	}
	
	public ReplyImpl(Metaset activity, WorkflowRuntimeContext rc, Stack stack,
			IRuntime runtime) {
		super(activity, rc, stack);
		this.runtime = runtime;
			}
}
