
package org.act.services.pool;

public interface IObjectPool {
	
	public static final int IN_MODE = 0;
	
	public static final int OUT_MODE = 1;
	
	public int size();
	public void setMaxSize(int size);
	public int getMaxSize();
	
	public Object get();
	public void put(Object obj);
	
	public boolean empty();
	public boolean full();
	
	public Object get(int i);
	public boolean remove(int i);
	
}
