package org.act.services;
import org.act.metaset.Metaset;
import org.act.services.ITransportContext.ResponseTransportContext;

public abstract class AMessageContext implements IMessageContext {
	
	private IAttachment[] requestAttachments;
	private Metaset requestServices;
	private IAttachment[] responseAttachments;
	private Metaset responseServices;
	private ResponseTransportContext responseTransportContext;
	private String servicesName;
	private int statusCode;
	
	public IAttachment[] getRequestAttachments() {
		return requestAttachments;
	}
	
	public void setRequestAttachments(IAttachment[] requestAttachments) {
		this.requestAttachments = requestAttachments;
	}
	
	public Metaset getRequestServices() {
		return requestServices;
	}
	
	public void setRequestServices(Metaset requestServices) {
		this.requestServices = requestServices;
	}
	
	public IAttachment[] getResponseAttachments() {
		return responseAttachments;
	}
	
	public void setResponseAttachments(IAttachment[] responseAttachments) {
		this.responseAttachments = responseAttachments;
	}
	
	public Metaset getResponseServices() {
		return responseServices;
	}
	
	public void setResponseServices(Metaset responseServices) {
		this.responseServices = responseServices;
	}
	
	public ResponseTransportContext getResponseTransportContext() {
		return responseTransportContext;
	}
	
	public void setResponseTransportContext(
			ResponseTransportContext responseTransportContext) {
		this.responseTransportContext = responseTransportContext;
	}
	
	public String getServicesName() {
		return servicesName;
	}
	
	public void setServicesName(String servicesName) {
		this.servicesName = servicesName;
	}
	
	
	
	public int getStatusCode() {
		return statusCode;
	}
	
	public void setStatusCode(int status) {
		this.statusCode = status;
	}
	
	public Object clone() throws CloneNotSupportedException {
		AMessageContext mc = (AMessageContext)super.clone();
		if (requestServices!=null)
		mc.requestServices = (Metaset) requestServices.clone();
		if (responseServices!=null)
		mc.responseServices = (Metaset) responseServices.clone();
		return mc;
	}
	
}
