package org.act.services;
import org.act.metaset.Metaset;

public interface IMessageContext extends Cloneable {
	
	public static final int CAN_NOT_CREATE_INSTANCE = 1;
	
		public String getMessageProtocolName();
	
		public int getStatusCode();
	public void setStatusCode(int status);
	
		public String getServicesName();
	public void setServicesName(String servicesName);
	
		public Metaset getRequestServices();
	public void setRequestServices(Metaset request);
	
		public Metaset getResponseServices();
	public void setResponseServices(Metaset response);
	
		public IAttachment[] getRequestAttachments();
	public void setRequestAttachments(IAttachment[] attachments);
	
		public IAttachment[] getResponseAttachments();
	public void setResponseAttachments(IAttachment[] attachments);
		public ITransportContext.ResponseTransportContext getResponseTransportContext();
	public void setResponseTransportContext(ITransportContext.ResponseTransportContext responseTransportContext);
		public Object clone() throws CloneNotSupportedException;
}
