
package org.act.services.wsrm;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public final class WSRMUtil {
	
	
	public static final boolean SupportTimerTask = false;
	public static final int MaxCacheCapacity = 11111;
	
	public WSRMUtil() {
		super();
	}
	 
	
		public static final Date stringParseDate(String s) {
		Date result = new Date();
	SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
        try {
    	result = SDF.parse(s);
    }
    catch (ParseException ex) {
    	ex.printStackTrace();
    }
    return result;
	}
	
		public static final int stringParseInteger(String s) {
		int duration = 0;
	try {
		duration = Integer.parseInt(s);
	}
	catch ( NumberFormatException ex) {
		ex.printStackTrace();
	}
	return duration;
	}	
	
		public static final long stringParseLong(String s) {
		long number = 0L;
	try {
		number = Long.parseLong(s);
	}
	catch ( NumberFormatException ex) {
		ex.printStackTrace();
	}
	return number;
	}	
	
		public static final boolean testExpiry(Date date) {
	    	boolean result = false;
	long currentTime = System.currentTimeMillis();
	long value = currentTime - date.getTime();
	if ( value > 0 ) {
		result = true;
	}
    return result;
	}
	
		public static final boolean testExpiry(long time) {
	boolean result = false;
	long currentTime = System.currentTimeMillis();
	long value = currentTime - time;
	if ( value > 0 ) {
		result = true;
	}
    return result;
	}
}
