
package org.act.services.transaction.util;

public class TxUri {
	  
    public static String buildTxId()
    {
        int random = (int)(java.lang.Math.random() * 10000);
        return Timer.getTime() + "-" + random ;
    }
    
    public static String buildUri(String url, String fragment)
    {
        return url + "#" + fragment;
    }
    
    public static String getTransactionIdFromUri(String str)
    {
        int i = str.indexOf('#');
        return str.substring(i + 1);
    }
    
    public static String getUrlFromUri(String str)
    {
        int i = str.indexOf('#');
        return (i <= 0 ? str : str.substring(0, i));
    }
    
    
    
    public static String getTxIdFromMessage(String message)
    {
        int pos1 = message.indexOf('[');
        int pos2 = message.indexOf(']');
        String txId = message.substring(pos1, pos2 + 1);
        return txId;
    }
    public static void main(String[] args)
    {
        TxUri txUri1 = new TxUri();
        String uri = TxUri.buildUri("url", TxUri.buildTxId());
        System.err.println(TxUri.getTransactionIdFromUri(uri));
        System.err.println(TxUri.getTxIdFromMessage(
            "<btp:begin id = '[12343436]'>"));
    }
}
