
package org.act.services.protocol.client;
import org.act.metaset.Metaset;
import org.act.services.ConfigException;
import org.act.services.IConfigurable;
import org.act.services.protocol.client.http.HttpCallClient;

public class CallClientFactory implements IConfigurable {
    private static String protocol = "HTTP";
    private static ICallClient callClient = null;
    
    public CallClientFactory() {
        super();
    }

    public static ICallClient CreatCallClientFactory() {
       
                        if (protocol.equals("HTTP")) {
                HttpCallClient httpCallClient = new HttpCallClient();
                callClient = httpCallClient;
            }
       
        return callClient;
    }
    
    public void config(Metaset config) throws ConfigException {
                protocol = "HTTP";
    }
}
