
package org.act.services.workflow.activity.basic;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;

public class ThrowImpl extends ActivityImpl {
	
													public void process() {
				super.process();
		
		String faultName = this.activity.selector(".\\", "faultName");
		String faultVariable = this.activity.selector(".\\", "faultVariable");
		Stack localKeepStack = this.rc.getLocalKeepStack();
		Metaset faultHandlers = this.rc.getFaultHandlers();
				if (!faultHandler(faultHandlers, faultName, faultVariable)) {
			for (int i = localKeepStack.size() - 4; i > 0; i = i - 6) {
				faultHandlers = (Metaset) localKeepStack.get(i);
				if (faultHandler(faultHandlers, faultName, faultVariable)) {
					break;
				}
			}
		}
	}
	
	public ThrowImpl(Metaset activity, WorkflowRuntimeContext rc,
			Stack stack) {
		super(activity, rc, stack);
			}
	
	
	private boolean faultHandler(Metaset faultHandlers, String faultName,
			String faultVariable) {
		Metaset pushContent = null;
				if (faultHandlers != null) {
						if (faultVariable == null) {
								Metaset handlers = faultHandlers.filter(".\\catch",
						"faultName", faultName);
				if (handlers != null) {
					for (int j = 0; j < handlers.getChilds().size(); j++) {
						Metaset handler = (Metaset) handlers
								.getChilds().get(j);
						if (handler.selector(".\\", "faultVariable") == null) {
							pushContent = handler.car();
						}
					}
				}
			}
						else {
				Metaset handlers = faultHandlers.filter(".\\catch",
						"faultVariable", faultVariable);
				Metaset Handlers = handlers.filter(".\\*", "faultName",
						faultName);
								if (Handlers != null) {
					pushContent = Handlers.car().car();
				}
								else {
					if (!handlers.isEmpty()) {
						pushContent = handlers.car().car();
					}
				}
			}
						Metaset catchAlls = faultHandlers.filter(".\\catchAll");
			if (catchAlls != null) {
				pushContent = catchAlls.car().car();
			}
		}
		if (pushContent != null) {
			this.stack.push(pushContent);
			return true;
		}
		return false;
	}
}
