
package org.act.services.workflow.management;

public class JVMInfo {
	  public JVMInfo() {
	  }
	  
	  public static long getJVMTotalM(int unitNum)
	  {
	    long unit;
	    switch (unitNum) {
	          case 0:
	            unit = 1;
	            break;
	          case 1:
	            unit = 1024;
	            break;
	          case 2:
	            unit = 1024*1024;
	            break;
	          default:
	            unit = 1;
	    }
	    return Runtime.getRuntime().totalMemory()/unit;
	  }
	  
	  public static long getJVMMaxM(int unitNum)
	  {
	    long unit;
	    switch (unitNum) {
	          case 0:
	            unit = 1;
	            break;
	          case 1:
	            unit = 1024;
	            break;
	          case 2:
	            unit = 1024*1024;
	            break;
	          default:
	            unit = 1;
	    }
	    return Runtime.getRuntime().maxMemory()/unit;
	  }
	  
	  public static long getJVMFreeM(int unitNum)
	  {
	    long unit;
	    switch (unitNum) {
	          case 0:
	            unit = 1;
	            break;
	          case 1:
	            unit = 1024;
	            break;
	          case 2:
	            unit = 1024*1024;
	            break;
	          default:
	            unit = 1;
	    }
	    return Runtime.getRuntime().freeMemory()/unit;
	  }
	  public static void main(String[] args)
	  {
	    System.out.println(JVMInfo.getJVMTotalM(0)+" byte");
	    System.out.println(JVMInfo.getJVMTotalM(1)+" k");
	    System.out.println(JVMInfo.getJVMTotalM(2)+" m");
	    System.out.println(JVMInfo.getJVMMaxM(0)+" byte");
	    System.out.println(JVMInfo.getJVMMaxM(1)+" k");
	    System.out.println(JVMInfo.getJVMMaxM(2)+" m");
	    System.out.println(JVMInfo.getJVMFreeM(0)+" byte");
	    System.out.println(JVMInfo.getJVMFreeM(1)+" k");
	    System.out.println(JVMInfo.getJVMFreeM(2)+" m");
	  }
	}
